## chicken 2.5

=== CMakeLists.txt ===
# Copyright (c) 2006 by Brandon J. Van Every under MIT-style license.
# See LICENSE section at end of file for full license text.

####################################################################
#  TUTORIAL                                                        #
####################################################################

# This is working code for building the Chicken Scheme-to-C compiler.
# It is also a tutorial for building non-trivial CMake projects.
# Please realize that the 1st mission of this code is always to
# build Chicken properly.  If a section is under-commented or under-
# explained, that's because nobody has had time to explain it.  It
# may also be deemed an unstable part of the build design, and
# thus not worthy of being documented, as it will likely change.
#
# Chicken developers: do not remove tutorial comments from the code.
# Brevity is not the goal here.  Aside from making both Chicken and
# CMake more accessible to newbies, it is important to have good
# documentation in case Brandon J. Van Every is hit by a truck.
#
# If you notice inaccuracies, inconsistencies, or ways that the 
# explanations can be improved, please report them on the
# Chicken mailing list.  You can always access the mailing list from
# the Chicken homepage:
#
#   http://www.call-with-current-continuation.org


####################################################################
#  CMAKE SPECIFIC ISSUES                                           #
####################################################################

# As this is also a tutorial for building non-trivial CMake projects,
# some words on how to utilize the CMake community.  Here are the
# basic resources:
#
#   read the docs that ship with CMake
#
#   CMake FAQ
#   http://www.cmake.org/Wiki/CMake_FAQ
#
#   CMake Useful Variables
#   http://www.cmake.org/Wiki/CMake_Useful_Variables
#   This is really important because the CMake 2.4.3 documentation
#   does not document the variables that CMake uses, and there are
#   quite a few of them.
#
#   CMake mailing list
#   http://www.cmake.org/mailman/listinfo/cmake
#   Once you've made a reasonable effort to read the docs, the FAQ,
#   and the Useful Variables, go straight to the mailing list and
#   ask questions.  The docs are terse and omit some important
#   things, like the CMake variables.  People on the mailing list
#   are very helpful and responsive.  This is the main way that
#   you'll get the best quality of support from the CMake community.
#
#   CMake mailing list archive
#   http://public.kitware.com/pipermail/cmake/
#   If you're a newbie, there's a good chance your questions have
#   been asked already.  Although people don't mind newbie questions,
#   you can often get your answers faster if you just look them up in
#   the archive.  There's no search facility on this page, so using
#   Google Advanced Search is a good idea.  Goto
#   http://www.google.com/advanced_search and for the Domain, enter
#   the URL of the mailing list archive.
#
#   CMake wiki
#   http://www.cmake.org/Wiki/CMake
#   This has tutorials and lots more info that you may find useful.
#
#   CMake Bug Tracker
#   http://www.cmake.org/Bug/
#   Use the bug tracker both to report bugs in CMake, and to make
#   Feature Requests.  You may want to discuss the bug or feature
#   request on the mailing list before making an official entry.
#   For instance, whether something is a bug or a feature request
#   may be in the realm of debate.  :-)  When filing bugs, it is
#   best to provide a trivial CMakeLists.txt that reproduces the
#   problem.  You can get help on more complicated pieces of code,
#   but if you've already isolated the problem, quick action is
#   more likely.


####################################################################
#  CMAKE VERSION                                                   #
####################################################################

# CMake undergoes rapid development.  Open source projects such as
# Chicken tend to stress CMake's capabilities, and bugs in CMake are
# frequently found.  Kitware is very good at reacting quickly to
# bugs and adding new features.  So good, that even minor releases
# can have significant differences in features available.  Do not
# expect old CMake binaries to simply work!  If your project is
# non-trivial, you are probably exploring non-trivial CMake
# capabilities somewhere, and backwards compatibility is not assured.

CMAKE_MINIMUM_REQUIRED(VERSION 2.4.3 FATAL_ERROR)

# Bugs typically show up in the current version of CMake you're using.
# Then you make a bug report to http://www.kitware.com/Bug , and
# often the bug gets fixed in the CVS repository.  Then you want to
# verify that the bug was actually fixed.  But, you want to keep
# running your old code, because the next version of CMake hasn't
# shipped and you don't expect people to be compiling CMake from CVS.
#
# To handle this, we need to know what version of CMake we're using.
# We already issue a fatal error for any CMake less than 2.4.3.
# So this is sufficient for distinguishing whether we've got
# CMake 2.4.3, or something greater.  We would ideally like to
# make lexical comparisons on CMake version numbers, and be able
# to say things like "if it's greater than version 2.x.y, do this."
# But that's work to implement, and this is easy and sufficient for now.

SET(IS_CMAKE_243 false)
IF(CMAKE_MAJOR_VERSION EQUAL 2)
  IF(CMAKE_MINOR_VERSION EQUAL 4)
    IF(CMAKE_PATCH_VERSION EQUAL 3)
      SET(IS_CMAKE_243 true)
    ENDIF(CMAKE_PATCH_VERSION EQUAL 3)
  ENDIF(CMAKE_MINOR_VERSION EQUAL 4)
ENDIF(CMAKE_MAJOR_VERSION EQUAL 2) 


####################################################################
#  CHICKEN PROJECT                                                 #
####################################################################

# All CMake projects need a name.  The name is global to all
# CMakeLists.txt in subdirectories.  Once you define a project
# named "myproject", the variable "myproject_SOURCE_DIR" exists.
# This is the toplevel source directory of your project, i.e.
# wherever your topmost CMakeLists.txt resides.
#
# You can also specify support for languages other than C, using
# additional arguments.  Chicken only needs C, so we don't bother.

PROJECT(Chicken)

# You can specify the order in which directories are searched for
# header files.  Chicken is a multi-directory project, so we do
# need to tell subdirectories where to find our toplevel *.h files.
# Also, the user may already have Chicken installed on their system.
# To avoid any possibility of picking up wrong header files from
# the system, we search our own directories BEFORE searching
# system directories.

INCLUDE_DIRECTORIES(BEFORE ${Chicken_SOURCE_DIR})


####################################################################
#  CHECKING HEADER FILES                                           #
####################################################################

# Typically we do not know if a header file, library, function, or
# other symbol is available on the system.  CMake has standard
# "modules" for checking their availability.  CMake "modules" are
# not available by default; if we want them, we have to explicitly
# INCLUDE them.
#
# CheckIncludeFile and CheckIncludeFiles do not do quite the same thing.
# CheckIncludeFile is the simpler case, when you only need 1 *.h file
# and it can be compiled in a straightforward manner into a trivial
# C test program.  Sometimes, however, multiple *.h files must be
# included together, in a specific sequence, and cannot be tested in
# isolation from one another.  Such is the case for WINSOCK *.h files,
# for instance.
#
# The interface for CheckIncludeFiles is more awkward.  Don't use it
# unless you really need it.  In particular, you will likely scratch
# your head about how exactly to specify a list of *.h files, so that
# CheckIncludeFiles actually takes it.

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)

# When you want to know if a specific function is available on your
# system, CheckFunctionExists is the module that people are likely to
# think of.  However, some "functions" are implemented as macros!
# CheckFunctionExists won't handle that.  CheckSymbolExists will.

INCLUDE(CheckSymbolExists)


####################################################################
#  DART DASHBOARD                                                  #
####################################################################

# CMake is integrated with a testing program called CTest.  It can
# create so-called "Dart Dashboards" on external websites.  These
# list the number of warnings and errors in a build.  If you write
# unit tests, the dashboard will list whether those tests pass or
# fail.  Information about your build can be dumped nightly, 
# continuously, or "experimentally" i.e. at any time you feel like.
#
# Chicken does not yet take full advantage of Dart Dashboard
# capabilities.  It is here as proof-of-concept.  This 1 line of
# code was sufficient to allow build results to be posted on the
# default Kitware public dashboard.  Over time, unit tests will be
# implemented and a canonical Dashboard of Chicken's status will
# be specified.

INCLUDE(Dart)


####################################################################
#  MACROS                                                          #
####################################################################

# CMake macros save work.  They are best employed:
#
# - to wrap up tasks that occur over and over again, i.e. as a
#   kind of function or subroutine.
#
# - to localize build rules in subdirectories, i.e. so you don't
#   have to type ${CMAKE_CURRENT_BINARY_DIR} all the time.
#
# CMake macros are also a way to obfuscate your code, make it
# unmaintainable, and render it illegible to others.  Don't get
# macro happy!  Programmers often think that abstraction and
# gratuitous refactoring is their job.  But, it's not the job of
# a Build Engineer.  Above all else, a Build Engineer needs to 
# Keep It Simple Stupid so that other people can understand,
# maintain, and spot problems with the build.
#
# This is why dumb lists of needed *.c files are often preferred to
# fancy build rules and macro wrap-ups.  It's easy for a programmer
# who doesn't know CMake to look through a simple list and spot files
# that need to be added, changed, or deleted.  They can use text
# editor search tools on such lists; they can't find weird production
# rules that do magical things to input strings.
#
# Prefer the straightforward CMake way to specify things, even if it
# is longer.   Some day, you're going to be asking someone on the CMake
# mailing list, "What's wrong with my code?"  If it's straightforward
# CMake code, you'll get snappy answers.  If you've wrapped it in 3
# bazillion layers of macros, nobody's going to be able to help you.  If
# you want someone to join your open source project as a build engineer,
# and they have to spend forever just figuring out how you
# macrotized everything, they're not going to bother.


####################################################################
#  TEXT UTILITIES                                                  #
####################################################################

# The text utilities evolved because handling lists properly in
# CMake can get confusing.  A list in CMake is a string of elements
# separated by semicolons.  So when is it a string, and when is it
# a list?  ${mylist} and "${mylist}" will give you completely different
# results; the quotes work as a sort of evaluator.
#
# Currently I am too lazy to explain all the nuances.
#
# Once you've figured out how to process your lists and strings properly,
# it is best to wrap up what you did and use it forever.  Otherwise you
# will make lotsa trivial mistakes over and over again.  I use FOREACH to
