## chicken 4.2.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Makefile - toplevel makefile
 #
 # Copyright (c) 2007, Felix L. Winkelmann
-# Copyright (c) 2008, The Chicken Team
+# Copyright (c) 2008-2009, The Chicken Team
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following
@@ -46,12 +46,9 @@
 	@echo "  $(MAKE) PLATFORM=cygwin"
 	@echo "  $(MAKE) PLATFORM=solaris"
 	@echo "  $(MAKE) PLATFORM=cross-linux-mingw"
-	@echo "  $(MAKE) PLATFORM=msvc"
 	@echo ""
 	@echo "For more information, consult the README file."
 	@exit 1
-dist:
-	csi -s scripts/makedist.scm
 else
 all:
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) all
@@ -80,4 +77,6 @@
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install-libs
 bootstrap:
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bootstrap
+bench:
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bench
 endif
