## chicken 4.5.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Makefile - toplevel makefile
 #
+# Copyright (c) 2008-2010, The Chicken Team
 # Copyright (c) 2007, Felix L. Winkelmann
-# Copyright (c) 2008-2009, The Chicken Team
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following
@@ -24,9 +24,18 @@
 # OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
+
+ifeq ($(CONFIG)$(PLATFORM),)
+CONFIG=config.make
+endif
+
+ifneq ($(CONFIG),)
+include $(CONFIG)
+endif
+
 STANDARD_TARGETS \
 	= all clean distclean spotless install uninstall confclean check \
-	  fullcheck dist libs install-libs bootstrap
+	  fullcheck dist libs
 
 SRCDIR = .
 
@@ -51,32 +60,26 @@
 	@exit 1
 else
 all:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) all
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) all
 clean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) clean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) clean
 distclean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) distclean
 spotless:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) spotless
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) spotless
 install:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) install
 uninstall:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) uninstall
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) uninstall
 confclean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) confclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) confclean
 check:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) check
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) check
 fullcheck:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) fullcheck
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) fullcheck
 dist:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distfiles
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) distfiles
 	csi -s scripts/makedist.scm
 libs:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) libs
-install-libs:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install-libs
-bootstrap:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bootstrap
-bench:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bench
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) libs
 endif
